#!/bin/bash

trap "echo;echo;echo 'ABORTED -- nothing was deleted.';echo" EXIT

cd /var/www/owncloud/apps
todelete='enterprise_key files_sharing_log files_ldap_home admin_audit windows_network_drive provisioning_api'

echo
echo "=================== W A R N I N G ====================="
echo
echo "This script irreversibly removes the following apps:-"
echo
apps_found=false
for app in $todelete; do
	if [ -d ${app} ] ; then
		apps_found=true
		NAME=`grep -oEi '<name>.*</name>' ${app}/appinfo/info.xml | cut -f 2 -d '>' | cut -f 1 -d '<'`
		echo -e "   ${app} (${NAME})"
	fi
done
if ! ${apps_found}; then
	echo "   (no commercial apps found)"
fi

cd /var/www/owncloud/themes
the_theme=`php -r 'include("/var/www/owncloud/config/config.php"); print $CONFIG["theme"];'`
themes_to_delete=
theme_is_active=false
themes=`find . -mindepth 1 -maxdepth 1 -type d | cut -c 3- | xargs`

for th in ${themes} ; do
	if [ -n "`ls ${th}`" ] ; then
		if grep -qi 'owncloud commercial license' `find ${th} -type f` ; then
			themes_to_delete="${themes_to_delete} ${th}"
			[ "${th}" = "${the_theme}" ] && theme_is_active=true
		fi
	fi
done
if [ -n "${themes_to_delete}" ] ; then
	echo
	echo "Additionally, the following themes will be removed:-"
	echo
	for th in ${themes_to_delete}; do
		echo "   ${th}"
	done
	echo
	if ${theme_is_active} ; then
		echo "Currently, '${the_theme}' is the active theme, so this"
		echo "setting will be removed as well."
		echo
	fi
fi

read -p "Enter 'yes' to confirm deletion: "

[ "${REPLY}" != 'yes' ] && exit

trap - EXIT

cd /var/www/owncloud/apps

if [ -n "${todelete}" ] ; then
	for app in $todelete; do
		if [ -d ${app} ] ; then
			echo "${app} exists - disabling..."
				/var/www/owncloud/occ app:disable ${app}
				rm -rf ${app}
		fi
	done
	echo
	echo "Remaining apps are now:-"
	echo
	/var/www/owncloud/occ app:list
fi

if [ -n "${themes_to_delete}" ] ; then
	cd /var/www/owncloud/themes
	echo
	for th in ${themes_to_delete} ; do
		echo "Removing theme '${th}' ..."
		rm -rf ${th}
	done
	echo
	echo "Remaining themes are now:-"
	echo
	find . -mindepth 1 -maxdepth 1 -type d | cut -c 3- | xargs -n 1 -i echo "  {}"
	echo
	if ${theme_is_active}; then
		echo "Removing theme config..."
		cd /var/www/owncloud/config
		CONF=config.php
		(
			echo '<?php'
			echo -n '$CONFIG = '
			php -r 'include("config.php"); unset($CONFIG["theme"]); unset($CONFIG["license-key"]); var_export($CONFIG);'
			echo ';'
		) >${CONF}.new
		chown www-data:www-data ${CONF}.new
		mv -f ${CONF}.new ${CONF}
		echo "Theme config removed."
		echo
	fi
fi
